%------------------------------------------------------------------------------%
% Module: generic_xml.m
% Author: Peter Ross <pro@missioncriticalit.com>
%
% Parse an xml file from stdin and build the generic xml structure.
%
%------------------------------------------------------------------------------%

/****M* libs/mexpat/samples/generic_xml.m/generic_xml
 * NAME
 *   generic_xml
 * PURPOSE
 *   <DOCXXX:module description>
 *         
 * AUTHOR
 *   <DOCXXX:list of authors>
 * HISTORY
 *   $Id: generic_xml.m,v 1.3 2004/12/09 14:13:28 winx821 Exp $ (use cvs log to get detailed history)
 * BUGS
 *   <bug descriptions>
 * TODO
 *   <list of todos>
 ****
 * <anything you want that won't be in the doc>
 */
 :- module generic_xml.

:- interface.

:- import_module io.

/****P* libs/mexpat/samples/generic_xml.m/main 
 * NAME
 *    main 
 * SYNOPSIS
 *    <DOCXXX:short descr for main >
 * FUNCTION
 *    <DOCXXX:description for main >
 * PARAMETERS
 *    <DOCXXX: types and modes and description for main>
 * RESULT
 *    <DOCXXX: determinism for main>
 * TODO
 *    <known todos for this function>
 ****
 * <anything you want that won't be in the doc>
 */
:- pred main(io::di, io::uo) is det.

%------------------------------------------------------------------------------%
%------------------------------------------------------------------------------%

:- implementation.

:- import_module mexpat, mexpat.xml.
:- import_module bool, require.

%------------------------------------------------------------------------------%

main(!IO) :-
    GenericXMLParser = parser_init,
    Parser = init(GenericXMLParser),
    main_2(Parser, _, !IO).


:- pred main_2(mexpat::in, mexpat::out, io::di, io::uo) is det.

main_2(!MExpat, !IO) :-
    io.read_line_as_string(R, !IO),
    ( R = ok(Str),
        xml_parse(Str, no, ParseResult, !MExpat),
        ( ParseResult = ok,
            write_output(!.MExpat, !IO),
            main_2(!MExpat, !IO)
        ; ParseResult = error(_, _, _),
            io.write(ParseResult, !IO),
            io.nl(!IO)
        )
    ; R = eof,
        xml_parse("", yes, ParseResult, !MExpat),
        ( ParseResult = ok,
            write_output(!.MExpat, !IO)
        ; ParseResult = error(_, _, _),
            io.write(ParseResult, !IO),
            io.nl(!IO)
        )
    ; R = error(_),
        io.write_string("IO error.\n", !IO)
    ).

:- pred write_output(mexpat::in, io::di, io::uo) is det.
write_output(MExpat, !IO) :-
    ( get_user_data(MExpat, UserData) ->
        ( get_element(UserData, Element) ->
            io.write(Element, !IO)
        ;
            io.write(UserData, !IO)
        ),
        io.nl(!IO)
    ;
        error("get_user_data: failed")
    ).

%------------------------------------------------------------------------------%
%------------------------------------------------------------------------------%
% vim: ft=mercury ts=4 sw=4 et tw=0 wm=0
